# Devolab OpenShift

Necessary files to deploy OpenShift 3.x on Devolab.

## Installation

### Prerequisites

1. Order an OpenStack Project on the ITPortal with sufficient quotas
1. Deploy a *bastion* VM, based on CentOS with the smallest available flavor.
1. Checkout this repo on your local machine
1. Update the `inventory/bastion-inventory` with your provisionned *bastion*
1. Run the `prereq_ansible_host.yml` playbook from your computer against the inventory:

```bash
ansible-playbook -i inventory/bastion-inventory prereq_ansible_host.yml -v
```

### Infrastructure provisionning

1. SSH into the *bastion* server
1. Checkout this repo and move into the directory
1. Edit the `inventory/group_vars/all.yml` to your liking
1. Clone the `release-3.11` branch from the [openshift-ansible](https://github.com/openshift/openshift-ansible/tree/release-3.11) repository:

```bash
git clone --single-branch --branch release-3.11 https://github.com/openshift/openshift-ansible.git
```

1. Run the provision playbook:

```bash
ansible-playbook --user openshift -i openshift-ansible/playbooks/openstack/inventory.py -i inventory openshift-ansible/playbooks/openstack/openshift-cluster/provision.yml -v
```

1. Run the `update_host_file.yml` playbook to update host files on each provisionned host (except if some DNSaaS has been put in place on Devolab).
1. Ask DNS administrator to add the following entries into Devolab DNS (put the correct IP addresses and replace `openshift.devolab.lan` with the correct domain name):

```
console.openshift.devolab.lan IN A <master_floating_IP>
*.apps.openshift.devolab.lan IN A <infra_floating_IP>
```

### OpenShift Installation

1. Edit the `inventory/group_vars/OSEv3.yml` to your liking
1. Edit the `extra_vars/auth_ldap.yml` with the LDAP account to use to bind to the LDAP server
1. Run the installation playbook:

```bash
ansible-playbook --user openshift -i openshift-ansible/playbooks/openstack/inventory.py -i inventory -e '@extra_vars/auth_ldap.yml' openshift-ansible/playbooks/openstack/openshift-cluster/install.yml -v
```


